#ifndef __PPU33_API__
#define __PPU33_API__

#ifdef __cplusplus
extern "C"
{
#endif

/* DLL support */
#ifndef ___EXPORT
	#define ___EXPORT
#endif

///////////////////////////////////////////////////////////////////////////////
//
//		NE-PPU-33 Library
//
//		2002.07.05
//		NextEye
//
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
//
//	Function :	PPU33_Open()
//				- Initialize NE-PPU-33
//					This function must be called 
//					before using PPU33_Read() or PPU33_Write()
//
//	Parameters:	flag - mostly, this flag is setted FALSE, but DELL PC is TRUE.
//						Using Maker PC, you must set this flag TRUE.
//
//	return :	return TRUE when NE-PPU-33 initialized.
//
///////////////////////////////////////////////////////////////////////////////

___EXPORT BOOL	PPU33_Open( BOOL flag );


///////////////////////////////////////////////////////////////////////////////
//
//	Function :	PPU33_Read()
//				- Read from input bit.
//
//	Parameters:	nBit - input bit( 0, 1, 2 )
//
//	return :	return TRUE when input is asserted.
//
///////////////////////////////////////////////////////////////////////////////

___EXPORT BOOL	PPU33_Read( int nBit );


///////////////////////////////////////////////////////////////////////////////
//
//	Function :	PPU33_Write()
//				- Initialize NE-PPU-33
//
//	Parameters:	nBit - output bit( 0, 1, 2 )
//				output - output operation ( TRUE or FALSE )
//
//	return :	void
//
///////////////////////////////////////////////////////////////////////////////

___EXPORT void	PPU33_Write( int nBit, BOOL output );


#ifdef __cplusplus
}
#endif

#endif