// PPU33Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "PPU33.h"
#include "PPU33Dlg.h"

#include "ppu33Api.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	LPT_TIMER		10
#define	LPT_TIMER_SPAN	100


#define	IO_TEST_TIME	500

DWORD	g_Count = 0;

BOOL	g_fIOThread = FALSE;

UINT IO_Thread( LPVOID pParam )
{
	CPPU33Dlg *pDlg = ( CPPU33Dlg* ) pParam;

	SYSTEMTIME st;
	CString str;

	BYTE rand_Value;
	BYTE flag;
	int i;

	pDlg->SetDlgItemText( IDC_BUTTON_TEST, "Test   ?" );

	while( g_fIOThread == TRUE ){
		flag = 0x01;
		g_Count++;
		rand_Value = rand() % 8;

		for(i = 0; i < 3; i++){
			if( rand_Value & flag ){
				pDlg->m_btnOutput[i].SetCheck(TRUE);
				PPU33_Write( i, TRUE );
			}
			else{
				pDlg->m_btnOutput[i].SetCheck(FALSE);
				PPU33_Write( i, FALSE );
			}
			flag <<= 1;

			Sleep(5);

			if( PPU33_Read( i ) )
				pDlg->m_btnInput[i].SetCheck(TRUE);
			else
				pDlg->m_btnInput[i].SetCheck(FALSE);

			if( pDlg->m_btnOutput[i].GetCheck() != pDlg->m_btnInput[i].GetCheck() ){
				GetLocalTime( &st );

				str.Format(" %016X : %02d %02d %02d - Է[%d] : [%d] = %s : %s\r\n",
							g_Count, st.wHour, st.wMinute, st.wSecond, i, i, 
							pDlg->m_btnOutput[i].GetCheck(), pDlg->m_btnInput[i].GetCheck() );

				pDlg->m_strError += str;

				pDlg->UpdateData(FALSE);
			}
		}
		Sleep(IO_TEST_TIME);
	}

	g_fIOThread = FALSE;
	pDlg->SetDlgItemText(IDC_BUTTON_TEST, "Test   ?");

	return 0;
}






/////////////////////////////////////////////////////////////////////////////
// CPPU33Dlg dialog

CPPU33Dlg::CPPU33Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPPU33Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPPU33Dlg)
	m_nPort = 0;
	m_strError = _T("Error Check");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPPU33Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPU33Dlg)
	DDX_Control(pDX, IDC_CHECK_INPUT2, m_btnInput[2]);
	DDX_Control(pDX, IDC_CHECK_INPUT1, m_btnInput[1]);
	DDX_Control(pDX, IDC_CHECK_INPUT0, m_btnInput[0]);
	DDX_Control(pDX, IDC_CHECK_OUTPUT2, m_btnOutput[2]);
	DDX_Control(pDX, IDC_CHECK_OUTPUT1, m_btnOutput[1]);
	DDX_Control(pDX, IDC_CHECK_OUTPUT0, m_btnOutput[0]);
	DDX_Text(pDX, IDC_EDIT_ERROR, m_strError);
	DDX_Control(pDX, IDC_BUTTON_TEST, m_btnTest);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPPU33Dlg, CDialog)
	//{{AFX_MSG_MAP(CPPU33Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHECK_OUTPUT0, OnCheckOutput0)
	ON_BN_CLICKED(IDC_CHECK_OUTPUT1, OnCheckOutput1)
	ON_BN_CLICKED(IDC_CHECK_OUTPUT2, OnCheckOutput2)
	ON_BN_CLICKED(IDC_BUTTON_TEST, OnButtonTest)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPU33Dlg message handlers

BOOL CPPU33Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	CString strTime;
	strTime.Format("  -  %dms\r\n\r\n", IO_TEST_TIME);

	m_strError += strTime;
	UpdateData(FALSE);

	if( PPU33_Open(TRUE) != TRUE )
		AfxMessageBox("Cannot Find Port");


	SetTimer(LPT_TIMER, LPT_TIMER_SPAN, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPPU33Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPPU33Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPPU33Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	for(int i = 0; i < 3; i++){
		if( PPU33_Read( i ) )
			m_btnInput[i].SetCheck(TRUE);
		else
			m_btnInput[i].SetCheck(FALSE);
		Sleep(10);
	}

	CDialog::OnTimer(nIDEvent);
}

void CPPU33Dlg::OnOK() 
{
	// TODO: Add extra validation here
	if( MessageBox("Ͻñ  ͸ Ͻðڽϱ?", NULL, MB_YESNO) == IDYES ){
		FILE *fp;
		char count[33];
		memset( count, 0, sizeof(count) );
		char *filename = (char *)calloc( 100, sizeof(char) );
		sprintf( filename, "ErrorInfo.txt");
		sprintf( count, "Count Data : %016X\r\n\r\n", g_Count);

		if( (fp = fopen("ErrorInfo.txt", "wt") ) != NULL){
			fwrite( count, sizeof(count), 1, fp);
			fwrite( m_strError, m_strError.GetLength(), 1, fp );
			fclose(fp);
		}
		else
			AfxMessageBox( "Error Info ϴµ Ͽϴ.", MB_ICONSTOP );
	
		free(filename);
	}

	CloseHandle( hPort );

	CDialog::OnOK();
}

void CPPU33Dlg::OnCheckOutput0() 
{
	if( m_btnOutput[0].GetCheck() == TRUE )
		PPU33_Write( 0, TRUE );
	else
		PPU33_Write( 0, FALSE);
}

void CPPU33Dlg::OnCheckOutput1() 
{
	if( m_btnOutput[1].GetCheck() == TRUE )
		PPU33_Write( 1, TRUE );
	else
		PPU33_Write( 1, FALSE);
}

void CPPU33Dlg::OnCheckOutput2() 
{
	if( m_btnOutput[2].GetCheck() == TRUE )
		PPU33_Write( 2, TRUE );
	else
		PPU33_Write( 2, FALSE);
}

void CPPU33Dlg::OnButtonTest() 
{
	// TODO: Add your control notification handler code here
	if( g_fIOThread == FALSE ){
		g_fIOThread = TRUE;
		KillTimer(LPT_TIMER);
		AfxBeginThread( IO_Thread, this );
	}
	else{
		g_fIOThread = FALSE;
		SetTimer(LPT_TIMER, LPT_TIMER_SPAN, NULL);
	}

}
